javax.el

## Class ArrayELResolver

- java.lang.Object
- - javax.el.ELResolver
  - - javax.el.ArrayELResolver

    public class ArrayELResolver
    extends ELResolver

Defines property resolution behavior on arrays.

This resolver handles base objects that are Java language arrays. It accepts any object as a property and coerces that object into an integer index into the array. The resulting value is the value in the array at that index.

This resolver can be constructed in read-only mode, which means that `isReadOnly` will always return `true` and `setValue(javax.el.ELContext, java.lang.Object, java.lang.Object, java.lang.Object)` will always throw `PropertyNotWritableException`.

`ELResolver`s are combined together using `CompositeELResolver`s, to define rich semantics for evaluating an expression. See the javadocs for `ELResolver` for details.

Since:
  JSP 2.1
See Also:
  `CompositeELResolver`, `ELResolver`

### Field Summary

### Fields inherited from class javax.el.ELResolver

`RESOLVABLE_AT_DESIGN_TIME, TYPE`

### Constructor Summary

Constructors
Constructor and Description
`ArrayELResolver()` Creates a new read/write `ArrayELResolver`.
`ArrayELResolver(boolean isReadOnly)` Creates a new `ArrayELResolver` whose read-only status is determined by the given parameter.

### Method Summary

Methods
`java.lang.Class<?>` `getCommonPropertyType(ELContext context, java.lang.Object base)` If the base object is a Java language array, returns the most general type that this resolver accepts for the `property` argument.
`java.util.Iterator<java.beans.FeatureDescriptor>` `getFeatureDescriptors(ELContext context, java.lang.Object base)` Always returns `null`, since there is no reason to iterate through set set of all integers.
`java.lang.Class<?>` `getType(ELContext context, java.lang.Object base, java.lang.Object property)` If the base object is an array, returns the most general acceptable type for a value in this array.
`java.lang.Object` `getValue(ELContext context, java.lang.Object base, java.lang.Object property)` If the base object is a Java language array, returns the value at the given index.
`boolean` `isReadOnly(ELContext context, java.lang.Object base, java.lang.Object property)` If the base object is a Java language array, returns whether a call to `setValue(javax.el.ELContext, java.lang.Object, java.lang.Object, java.lang.Object)` will always fail.
`void` `setValue(ELContext context, java.lang.Object base, java.lang.Object property, java.lang.Object val)` If the base object is a Java language array, attempts to set the value at the given index with the given value.

### Methods inherited from class javax.el.ELResolver

`convertToType, invoke`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### ArrayELResolver

    public ArrayELResolver()

Creates a new read/write `ArrayELResolver`.

#### ArrayELResolver

    public ArrayELResolver(boolean isReadOnly)

Creates a new `ArrayELResolver` whose read-only status is determined by the given parameter.

Parameters:
  `isReadOnly` - `true` if this resolver cannot modify arrays; `false` otherwise.

### Method Detail

#### getType

    public java.lang.Class<?> getType(ELContext context,
                             java.lang.Object base,
                             java.lang.Object property)

If the base object is an array, returns the most general acceptable type for a value in this array.

If the base is a `array`, the `propertyResolved` property of the `ELContext` object must be set to `true` by this resolver, before returning. If this property is not `true` after this method is called, the caller should ignore the return value.

Assuming the base is an `array`, this method will always return `base.getClass().getComponentType()`, which is the most general type of component that can be stored at any given index in the array.

Specified by:
  `getType` in class `ELResolver`
Parameters:
  `context` - The context of this evaluation.
  `base` - The array to analyze. Only bases that are Java language arrays are handled by this resolver.
  `property` - The index of the element in the array to return the acceptable type for. Will be coerced into an integer, but otherwise ignored by this resolver.
Returns:
  If the `propertyResolved` property of `ELContext` was set to `true`, then the most general acceptable type; otherwise undefined.
Throws:
  `PropertyNotFoundException` - if the given index is out of bounds for this array.
  `java.lang.NullPointerException` - if context is `null`
  `ELException` - if an exception was thrown while performing the property or variable resolution. The thrown exception must be included as the cause property of this exception, if available.

#### getValue

    public java.lang.Object getValue(ELContext context,
                            java.lang.Object base,
                            java.lang.Object property)

If the base object is a Java language array, returns the value at the given index. The index is specified by the `property` argument, and coerced into an integer. If the coercion could not be performed, an `IllegalArgumentException` is thrown. If the index is out of bounds, `null` is returned.

If the base is a Java language array, the `propertyResolved` property of the `ELContext` object must be set to `true` by this resolver, before returning. If this property is not `true` after this method is called, the caller should ignore the return value.

Specified by:
  `getValue` in class `ELResolver`
Parameters:
  `context` - The context of this evaluation.
  `base` - The array to analyze. Only bases that are Java language arrays are handled by this resolver.
  `property` - The index of the value to be returned. Will be coerced into an integer.
Returns:
  If the `propertyResolved` property of `ELContext` was set to `true`, then the value at the given index or `null` if the index was out of bounds. Otherwise, undefined.
Throws:
  `java.lang.IllegalArgumentException` - if the property could not be coerced into an integer.
  `java.lang.NullPointerException` - if context is `null`.
  `ELException` - if an exception was thrown while performing the property or variable resolution. The thrown exception must be included as the cause property of this exception, if available.

#### setValue

    public void setValue(ELContext context,
                java.lang.Object base,
                java.lang.Object property,
                java.lang.Object val)

If the base object is a Java language array, attempts to set the value at the given index with the given value. The index is specified by the `property` argument, and coerced into an integer. If the coercion could not be performed, an `IllegalArgumentException` is thrown. If the index is out of bounds, a `PropertyNotFoundException` is thrown.

If the base is a Java language array, the `propertyResolved` property of the `ELContext` object must be set to `true` by this resolver, before returning. If this property is not `true` after this method is called, the caller can safely assume no value was set.

If this resolver was constructed in read-only mode, this method will always throw `PropertyNotWritableException`.

Specified by:
  `setValue` in class `ELResolver`
Parameters:
  `context` - The context of this evaluation.
  `base` - The array to be modified. Only bases that are Java language arrays are handled by this resolver.
  `property` - The index of the value to be set. Will be coerced into an integer.
  `val` - The value to be set at the given index.
Throws:
  `java.lang.ClassCastException` - if the class of the specified element prevents it from being added to this array.
  `java.lang.NullPointerException` - if context is `null`.
  `java.lang.IllegalArgumentException` - if the property could not be coerced into an integer, or if some aspect of the specified element prevents it from being added to this array.
  `PropertyNotWritableException` - if this resolver was constructed in read-only mode.
  `PropertyNotFoundException` - if the given index is out of bounds for this array.
  `ELException` - if an exception was thrown while performing the property or variable resolution. The thrown exception must be included as the cause property of this exception, if available.

#### isReadOnly

    public boolean isReadOnly(ELContext context,
                     java.lang.Object base,
                     java.lang.Object property)

If the base object is a Java language array, returns whether a call to `setValue(javax.el.ELContext, java.lang.Object, java.lang.Object, java.lang.Object)` will always fail.

If the base is a Java language array, the `propertyResolved` property of the `ELContext` object must be set to `true` by this resolver, before returning. If this property is not `true` after this method is called, the caller should ignore the return value.

If this resolver was constructed in read-only mode, this method will always return `true`. Otherwise, it returns `false`.

Specified by:
  `isReadOnly` in class `ELResolver`
Parameters:
  `context` - The context of this evaluation.
  `base` - The array to analyze. Only bases that are a Java language array are handled by this resolver.
  `property` - The index of the element in the array to return the acceptable type for. Will be coerced into an integer, but otherwise ignored by this resolver.
Returns:
  If the `propertyResolved` property of `ELContext` was set to `true`, then `true` if calling the `setValue` method will always fail or `false` if it is possible that such a call may succeed; otherwise undefined.
Throws:
  `PropertyNotFoundException` - if the given index is out of bounds for this array.
  `java.lang.NullPointerException` - if context is `null`
  `ELException` - if an exception was thrown while performing the property or variable resolution. The thrown exception must be included as the cause property of this exception, if available.

#### getFeatureDescriptors

    public java.util.Iterator<java.beans.FeatureDescriptor> getFeatureDescriptors(ELContext context,
                                                                         java.lang.Object base)

Always returns `null`, since there is no reason to iterate through set set of all integers.

The `getCommonPropertyType(javax.el.ELContext, java.lang.Object)` method returns sufficient information about what properties this resolver accepts.

Specified by:
  `getFeatureDescriptors` in class `ELResolver`
Parameters:
  `context` - The context of this evaluation.
  `base` - The array to analyze. Only bases that are a Java language array are handled by this resolver.
Returns:
  `null`.
See Also:
  `FeatureDescriptor`

#### getCommonPropertyType

    public java.lang.Class<?> getCommonPropertyType(ELContext context,
                                           java.lang.Object base)

If the base object is a Java language array, returns the most general type that this resolver accepts for the `property` argument. Otherwise, returns `null`.

Assuming the base is an array, this method will always return `Integer.class`. This is because arrays accept integers for their index.

Specified by:
  `getCommonPropertyType` in class `ELResolver`
Parameters:
  `context` - The context of this evaluation.
  `base` - The array to analyze. Only bases that are a Java language array are handled by this resolver.
Returns:
  `null` if base is not a Java language array; otherwise `Integer.class`.